-#!/bin/sh -f
+#!/bin/sh
CACHE=$HOME/.dmenu_cache
IFS=:
-qfind() {
- find "$@" 2>/dev/null
-}
-
-uptodate() {
- test -f $CACHE &&
- test "$(echo "$PATH")" = "$(sed 1q "$CACHE")" &&
- qfind $PATH -maxdepth 0 -newer $CACHE
-}
-
-if ! uptodate
-then
- {
- echo "$PATH"
- qfind $PATH -type f -maxdepth 1 '(' -perm -u+x -o -perm -g+x -o -perm -o+x ')' |
- sed 's,.*/,,' | sort | uniq
- } > $CACHE.$pid
- mv $CACHE.$pid $CACHE
+if ! test -f "$CACHE" || find $PATH -type d -newer "$CACHE" | grep -q .; then
+ find $PATH ! -type d \( -perm -1 -o -perm -10 -o -perm -100 \) | sed 's/.*\///' | sort -u > "$CACHE"
fi
-tail -n +2 $CACHE
-
+cat "$CACHE"